// This file is part of Substrate.

// Copyright (C) 2021 Parity Technologies (UK) Ltd.
// SPDX-License-Identifier: Apache-2.0

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

//! Autogenerated weights for pallet_corporate_actions
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 3.0.0
//! DATE: 2021-09-22, STEPS: [100, ], REPEAT: 5, LOW RANGE: [], HIGH RANGE: []
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: None, DB CACHE: 512

// Executed Command:
// ./target/release/polymesh
// benchmark
// -s
// 100
// -r
// 5
// -p=pallet_corporate_actions
// -e=*
// --heap-pages
// 4096
// --db-cache
// 512
// --execution
// wasm
// --wasm-execution
// compiled
// --output
// ./pallets/weights/src/
// --template
// ./.maintain/frame-weight-template.hbs
// --raw

#![allow(unused_parens)]
#![allow(unused_imports)]

use polymesh_runtime_common::{RocksDbWeight as DbWeight, Weight};

/// Weights for pallet_corporate_actions using the Substrate node and recommended hardware.
pub struct WeightInfo;
impl pallet_corporate_actions::WeightInfo for WeightInfo {
    fn set_max_details_length() -> Weight {
        (19_892_000 as Weight).saturating_add(DbWeight::get().writes(1 as Weight))
    }
    fn set_default_targets(t: u32) -> Weight {
        (87_605_000 as Weight)
            // Standard Error: 5_000
            .saturating_add((516_000 as Weight).saturating_mul(t as Weight))
            .saturating_add(DbWeight::get().reads(6 as Weight))
            .saturating_add(DbWeight::get().writes(1 as Weight))
    }
    fn set_default_withholding_tax() -> Weight {
        (65_777_000 as Weight)
            .saturating_add(DbWeight::get().reads(6 as Weight))
            .saturating_add(DbWeight::get().writes(1 as Weight))
    }
    fn set_did_withholding_tax(w: u32) -> Weight {
        (106_758_000 as Weight)
            // Standard Error: 2_000
            .saturating_add((229_000 as Weight).saturating_mul(w as Weight))
            .saturating_add(DbWeight::get().reads(6 as Weight))
            .saturating_add(DbWeight::get().writes(1 as Weight))
    }
    fn initiate_corporate_action_use_defaults(w: u32, t: u32) -> Weight {
        (252_814_000 as Weight)
            // Standard Error: 4_000
            .saturating_add((316_000 as Weight).saturating_mul(w as Weight))
            // Standard Error: 9_000
            .saturating_add((225_000 as Weight).saturating_mul(t as Weight))
            .saturating_add(DbWeight::get().reads(16 as Weight))
            .saturating_add(DbWeight::get().writes(6 as Weight))
    }
    fn initiate_corporate_action_provided(w: u32, t: u32) -> Weight {
        (241_961_000 as Weight)
            // Standard Error: 5_000
            .saturating_add((358_000 as Weight).saturating_mul(w as Weight))
            // Standard Error: 10_000
            .saturating_add((385_000 as Weight).saturating_mul(t as Weight))
            .saturating_add(DbWeight::get().reads(13 as Weight))
            .saturating_add(DbWeight::get().writes(6 as Weight))
    }
    fn link_ca_doc(d: u32) -> Weight {
        (0 as Weight)
            // Standard Error: 47_000
            .saturating_add((8_611_000 as Weight).saturating_mul(d as Weight))
            .saturating_add(DbWeight::get().reads(7 as Weight))
            .saturating_add(DbWeight::get().reads((1 as Weight).saturating_mul(d as Weight)))
            .saturating_add(DbWeight::get().writes(1 as Weight))
    }
    fn remove_ca_with_ballot() -> Weight {
        (113_214_000 as Weight)
            .saturating_add(DbWeight::get().reads(9 as Weight))
            .saturating_add(DbWeight::get().writes(8 as Weight))
    }
    fn remove_ca_with_dist() -> Weight {
        (126_477_000 as Weight)
            .saturating_add(DbWeight::get().reads(10 as Weight))
            .saturating_add(DbWeight::get().writes(6 as Weight))
    }
    fn change_record_date_with_ballot() -> Weight {
        (147_925_000 as Weight)
            .saturating_add(DbWeight::get().reads(14 as Weight))
            .saturating_add(DbWeight::get().writes(5 as Weight))
    }
    fn change_record_date_with_dist() -> Weight {
        (149_236_000 as Weight)
            .saturating_add(DbWeight::get().reads(14 as Weight))
            .saturating_add(DbWeight::get().writes(5 as Weight))
    }
}
